﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FrequencyConverterMonitor
{
    /// <summary>
    /// Логика взаимодействия для DeviceWindow.xaml
    /// </summary>
    public partial class DeviceWindow : Window
    {
        public DeviceWindow()
        {
            InitializeComponent();
            var ds = DeviceConfig.GetTempldates();
            foreach (var d in ds) cbType.Items.Add(d);
            if (cbType.Items.Count > 0) cbType.SelectedIndex = 0;
        }

        public DeviceInfo CreateDevice(MainWindow owner, string name)
        {
            this.txName.Text = name;
            this.Owner = owner;
            if (this.ShowDialog() == true)
            {
                DeviceInfo info = new DeviceInfo();
                info.MainWindow = owner;
                info.Init(txName.Text, int.Parse(txNumber.Text), cbActive.IsChecked.Value, cbType.SelectedItem as DeviceConfig);
                return info;
            }
            return null;
        }

        public DeviceInfo EditDevice(DeviceInfo device)
        {
            this.Title = "Редактировать устройство";
            this.txName.Text = device.Name;
            this.Owner = device.MainWindow;
            txNumber.Text = device.DeviceNumber.ToString();
            cbActive.IsChecked = device.Active;
            cbType.SelectedItem = null;
            foreach (DeviceConfig t in cbType.Items) if (t.Equals(device.Config)) cbType.SelectedItem = t;

            bOk.Content = "ОК";

            if (this.ShowDialog() == true)
            {
                if (cbType.SelectedItem != null)
                {
                    device.Init(txName.Text, int.Parse(txNumber.Text), cbActive.IsChecked.Value, (DeviceConfig)cbType.SelectedItem);
                    return device;
                }
            }
            return null;
        }

        private void bOk_Click(object sender, RoutedEventArgs e)
        {
            if (!int.TryParse(txNumber.Text, out int i) || i <= 0 || i >= 255)
            {
                MessageBox.Show(this, "Неверный формат адреса прибора!", "", MessageBoxButton.OK, MessageBoxImage.Error);
                txNumber.Focus();
            }
            else
            {
                this.DialogResult = true;
                this.Close();
            }
        }

        private void bCancel_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
            this.Close();
        }

    }
}
