﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FrequencyConverterMonitor
{
    /// <summary>
    /// Логика взаимодействия для InputParamWindow.xaml
    /// </summary>
    public partial class InputParamWindow : Window
    {
        DeviceInfo _device;
        SlideParam _param;

        public InputParamWindow()
        {
            InitializeComponent();
        }

        public bool ShowDialog(DeviceInfo device, SlideParam param)
        {
            _device = device;
            _param = param;

            this.Owner = device.MainWindow;
            this.pName.Text = param.Caption;
            nupValue.LoadFromParamInfo(param);
            nupValue.Value = param.DoubleValue;
            this.ShowDialog();
            return true;
        }

        private void bOk_Click(object sender, RoutedEventArgs e)
        {
            double? value = nupValue.Value.Value;

            if (!value.HasValue)
            {
                MessageBox.Show(this, "Введите значение!");
            }
            else
            {
                ushort data = unchecked((ushort)((_param.ModbusValue ?? 0) & 0xFFFF));
                if (_device.WriteParamValue((int)_param.WriteModbusFunction, (int)_param.RegNumber, data))
                {
                    //ok
                    this.DialogResult = true;
                    this.Close();
                }
                else
                {
                    MessageBox.Show(this, "Ошибка записи значения", "", MessageBoxButton.OK, MessageBoxImage.Error);
                }
            }
        }
    }
}
